diff --git a/src/conf/cards/Audigy.conf b/src/conf/cards/Audigy.conf
index 1c924966..42692cfd 100644
--- a/src/conf/cards/Audigy.conf
+++ b/src/conf/cards/Audigy.conf
@@ -26,31 +26,14 @@ Audigy.pcm.front.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0 ]
-			}
-
 		]
 	}
 }	
@@ -79,14 +62,6 @@ Audigy.pcm.rear.0 {
 				optional true
 				value [ 0 0 255 255 0 0 0 0  0 0 255 0 0 0 0 0  0 0 0 255 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 0 0 255 255 0 0 0 0  0 0 255 0 0 0 0 0  0 0 0 255 0 0 0 0 ]
-			}
 		]
 	}
 }	
@@ -115,30 +90,14 @@ Audigy.pcm.center_lfe.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0 ]
-			}
 		]
 	}
 }	
@@ -265,14 +224,6 @@ Audigy.pcm.iec958.0 {
 				optional true
 				value [ $AES0 $AES1 $AES2 $AES3 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "IEC958 Playback Default"
-				lock true
-				preserve true
-				optional true
-				value [ $AES0 $AES1 $AES2 $AES3 ]
-			}
 			{
 				name "IEC958 Optical Raw Playback Switch"
 				lock true
@@ -287,30 +238,14 @@ Audigy.pcm.iec958.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 20 21 0 0 0 0 0 0  20 21 0 0 0 0 0 0   20 21 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 20 21 0 0 0 0 0 0  20 21 0 0 0 0 0 0   20 21 0 0 0 0 0 0 ]
-			}
 			{
 				name "Audigy Analog/Digital Output Jack"
 				lock true
diff --git a/src/conf/cards/Audigy2.conf b/src/conf/cards/Audigy2.conf
index cbec7835..35126d23 100644
--- a/src/conf/cards/Audigy2.conf
+++ b/src/conf/cards/Audigy2.conf
@@ -26,30 +26,14 @@ Audigy2.pcm.front.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0  8 9 0 0 0 0 0 0 ]
-			}
 
 		]
 	}
@@ -79,14 +63,6 @@ Audigy2.pcm.rear.0 {
 				optional true
 				value [ 0 0 255 255 0 0 0 0  0 0 255 0 0 0 0 0  0 0 0 255 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 0 0 255 255 0 0 0 0  0 0 255 0 0 0 0 0  0 0 0 255 0 0 0 0 ]
-			}
 		]
 	}
 }	
@@ -115,30 +91,14 @@ Audigy2.pcm.center_lfe.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0  6 7 0 0 0 0 0 0 ]
-			}
 		]
 	}
 }
@@ -167,30 +127,14 @@ Audigy2.pcm.side.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 14 15 0 0 0 0 0 0  14 15 0 0 0 0 0 0  14 15 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 14 15 0 0 0 0 0 0  14 15 0 0 0 0 0 0  14 15 0 0 0 0 0 0 ]
-			}
 		]
 	}
 }
@@ -374,13 +318,6 @@ Audigy2.pcm.iec958.0 {
 				optional true
 				value [ $AES0 $AES1 $AES2 $AES3 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "IEC958 Playback Default"
-				preserve true
-				optional true
-				value [ $AES0 $AES1 $AES2 $AES3 ]
-			}
 			{
 				name "IEC958 Optical Raw Playback Switch"
 				lock true
@@ -395,30 +332,14 @@ Audigy2.pcm.iec958.0 {
 				optional true
 				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Volume"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 255 255 0 0 0 0 0 0  255 0 0 0 0 0 0 0  0 255 0 0 0 0 0 0 ]
-			}
 			{
 				interface PCM
 				name "EMU10K1 PCM Send Routing"
 				index { @func private_pcm_subdevice }
 				lock true
 				optional true
 				value [ 20 21 0 0 0 0 0 0  20 21 0 0 0 0 0 0   20 21 0 0 0 0 0 0 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "EMU10K1 PCM Send Routing"
-				index { @func private_pcm_subdevice }
-				lock true
-				optional true
-				value [ 20 21 0 0 0 0 0 0  20 21 0 0 0 0 0 0   20 21 0 0 0 0 0 0 ]
-			}
 			{
 				name "Audigy Analog/Digital Output Jack"
 				lock true
diff --git a/src/conf/cards/EMU10K1.conf b/src/conf/cards/EMU10K1.conf
index ef193fe0..430926c7 100644
--- a/src/conf/cards/EMU10K1.conf
+++ b/src/conf/cards/EMU10K1.conf
@@ -28,30 +28,14 @@ EMU10K1.pcm.front.0 {
 					optional true
 					value [ 255 255 0 0 255 0 0 0 0 255 0 0 ]
 				}
-				{
-					# for compatibility with older drivers
-					name "EMU10K1 PCM Send Volume"
-					index { @func private_pcm_subdevice }
-					# lock true
-					optional true
-					value [ 255 255 0 0 255 0 0 0 0 255 0 0 ]
-				}
 				{
 					interface PCM
 					name "EMU10K1 PCM Send Routing"
 					index { @func private_pcm_subdevice }
 					# lock true
 					optional true
 					value [ 8 9 0 0 8 9 0 0 8 9 0 0 ]
 				}
-				{
-					# for compatibility with older drivers
-					name "EMU10K1 PCM Send Routing"
-					index { @func private_pcm_subdevice }
-					# lock true
-					optional true
-					value [ 8 9 0 0 8 9 0 0 8 9 0 0 ]
-				}
 			]
 		}
 	}
@@ -87,14 +71,6 @@ EMU10K1.pcm.rear.0 {
 					optional true
 					value [ 0 0 255 255 0 0 255 0 0 0 0 255 ]
 				}
-				{
-					# for compatibility with older drivers
-					name "EMU10K1 PCM Send Volume"
-					index { @func private_pcm_subdevice }
-					# lock true
-					optional true
-					value [ 0 0 255 255 0 0 255 0 0 0 0 255 ]
-				}
 			]
 		}
 	}
@@ -152,30 +128,14 @@ EMU10K1.pcm.center_lfe.0 {
 					optional true
 					value [ 255 255 0 0 255 0 0 0 0 255 0 0 ]
 				}
-				{
-					# for compatibility with older drivers
-					name "EMU10K1 PCM Send Volume"
-					index { @func private_pcm_subdevice }
-					# lock true
-					optional true
-					value [ 255 255 0 0 255 0 0 0 0 255 0 0 ]
-				}
 				{
 					interface PCM
 					name "EMU10K1 PCM Send Routing"
 					index { @func private_pcm_subdevice }
 					# lock true
 					optional true
 					value [ 6 7 0 0 6 7 0 0 6 7 0 0 ]
 				}
-				{
-					# for compatibility with older drivers
-					name "EMU10K1 PCM Send Routing"
-					index { @func private_pcm_subdevice }
-					# lock true
-					optional true
-					value [ 6 7 0 0 6 7 0 0 6 7 0 0 ]
-				}
 			]
 		}
 	}
@@ -304,14 +264,6 @@ EMU10K1.pcm.iec958.0 {
 				optional true
 				value [ $AES0 $AES1 $AES2 $AES3 ]
 			}
-			{
-				# for compatibility with older drivers
-				name "IEC958 Playback Default"
-				lock true
-				preserve true
-				optional true
-				value [ $AES0 $AES1 $AES2 $AES3 ]
-			}
 			{
 				name "IEC958 Optical Raw Playback Switch"
 				lock true